# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DataforseoLabsAvailableFiltersBingInfo(BaseModel):
    """
    DataforseoLabsAvailableFiltersBingInfo
    """ # noqa: E501
    depth: Optional[StrictStr] = None
    keyword_data_keyword: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword")
    keyword_data_keyword_info_last_updated_time: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_info.last_updated_time")
    keyword_data_keyword_info_competition: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_info.competition")
    keyword_data_keyword_info_cpc: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_info.cpc")
    keyword_data_keyword_info_search_volume: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_info.search_volume")
    keyword_data_keyword_properties_core_keyword: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_properties.core_keyword")
    keyword_data_keyword_properties_synonym_clustering_algorithm: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_properties.synonym_clustering_algorithm")
    keyword_data_keyword_properties_keyword_difficulty: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_properties.keyword_difficulty")
    keyword_data_keyword_properties_detected_language: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_properties.detected_language")
    keyword_data_keyword_properties_is_another_language: Optional[StrictStr] = Field(default=None, alias="keyword_data.keyword_properties.is_another_language")
    keyword_data_serp_info_check_url: Optional[StrictStr] = Field(default=None, alias="keyword_data.serp_info.check_url")
    keyword_data_serp_info_se_results_count: Optional[StrictInt] = Field(default=None, alias="keyword_data.serp_info.se_results_count")
    keyword_data_serp_info_last_updated_time: Optional[StrictStr] = Field(default=None, alias="keyword_data.serp_info.last_updated_time")
    keyword_data_serp_info_previous_updated_time: Optional[StrictStr] = Field(default=None, alias="keyword_data.serp_info.previous_updated_time")
    keyword_data_serp_info_serp_item_types: Optional[StrictStr] = Field(default=None, alias="keyword_data.serp_info.serp_item_types")
    __properties: ClassVar[List[str]] = ["depth", "keyword_data.keyword", "keyword_data.keyword_info.last_updated_time", "keyword_data.keyword_info.competition", "keyword_data.keyword_info.cpc", "keyword_data.keyword_info.search_volume", "keyword_data.keyword_properties.core_keyword", "keyword_data.keyword_properties.synonym_clustering_algorithm", "keyword_data.keyword_properties.keyword_difficulty", "keyword_data.keyword_properties.detected_language", "keyword_data.keyword_properties.is_another_language", "keyword_data.serp_info.check_url", "keyword_data.serp_info.se_results_count", "keyword_data.serp_info.last_updated_time", "keyword_data.serp_info.previous_updated_time", "keyword_data.serp_info.serp_item_types"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataforseoLabsAvailableFiltersBingInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if depth (nullable) is None
        # and model_fields_set contains the field
        if self.depth is None and "depth" in self.model_fields_set:
            _dict['depth'] = None

        # set to None if keyword_data_keyword (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword is None and "keyword_data_keyword" in self.model_fields_set:
            _dict['keyword_data.keyword'] = None

        # set to None if keyword_data_keyword_info_last_updated_time (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_info_last_updated_time is None and "keyword_data_keyword_info_last_updated_time" in self.model_fields_set:
            _dict['keyword_data.keyword_info.last_updated_time'] = None

        # set to None if keyword_data_keyword_info_competition (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_info_competition is None and "keyword_data_keyword_info_competition" in self.model_fields_set:
            _dict['keyword_data.keyword_info.competition'] = None

        # set to None if keyword_data_keyword_info_cpc (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_info_cpc is None and "keyword_data_keyword_info_cpc" in self.model_fields_set:
            _dict['keyword_data.keyword_info.cpc'] = None

        # set to None if keyword_data_keyword_info_search_volume (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_info_search_volume is None and "keyword_data_keyword_info_search_volume" in self.model_fields_set:
            _dict['keyword_data.keyword_info.search_volume'] = None

        # set to None if keyword_data_keyword_properties_core_keyword (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_properties_core_keyword is None and "keyword_data_keyword_properties_core_keyword" in self.model_fields_set:
            _dict['keyword_data.keyword_properties.core_keyword'] = None

        # set to None if keyword_data_keyword_properties_synonym_clustering_algorithm (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_properties_synonym_clustering_algorithm is None and "keyword_data_keyword_properties_synonym_clustering_algorithm" in self.model_fields_set:
            _dict['keyword_data.keyword_properties.synonym_clustering_algorithm'] = None

        # set to None if keyword_data_keyword_properties_keyword_difficulty (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_properties_keyword_difficulty is None and "keyword_data_keyword_properties_keyword_difficulty" in self.model_fields_set:
            _dict['keyword_data.keyword_properties.keyword_difficulty'] = None

        # set to None if keyword_data_keyword_properties_detected_language (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_properties_detected_language is None and "keyword_data_keyword_properties_detected_language" in self.model_fields_set:
            _dict['keyword_data.keyword_properties.detected_language'] = None

        # set to None if keyword_data_keyword_properties_is_another_language (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_keyword_properties_is_another_language is None and "keyword_data_keyword_properties_is_another_language" in self.model_fields_set:
            _dict['keyword_data.keyword_properties.is_another_language'] = None

        # set to None if keyword_data_serp_info_check_url (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_serp_info_check_url is None and "keyword_data_serp_info_check_url" in self.model_fields_set:
            _dict['keyword_data.serp_info.check_url'] = None

        # set to None if keyword_data_serp_info_se_results_count (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_serp_info_se_results_count is None and "keyword_data_serp_info_se_results_count" in self.model_fields_set:
            _dict['keyword_data.serp_info.se_results_count'] = None

        # set to None if keyword_data_serp_info_last_updated_time (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_serp_info_last_updated_time is None and "keyword_data_serp_info_last_updated_time" in self.model_fields_set:
            _dict['keyword_data.serp_info.last_updated_time'] = None

        # set to None if keyword_data_serp_info_previous_updated_time (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_serp_info_previous_updated_time is None and "keyword_data_serp_info_previous_updated_time" in self.model_fields_set:
            _dict['keyword_data.serp_info.previous_updated_time'] = None

        # set to None if keyword_data_serp_info_serp_item_types (nullable) is None
        # and model_fields_set contains the field
        if self.keyword_data_serp_info_serp_item_types is None and "keyword_data_serp_info_serp_item_types" in self.model_fields_set:
            _dict['keyword_data.serp_info.serp_item_types'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataforseoLabsAvailableFiltersBingInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "depth": obj.get("depth"),
            "keyword_data.keyword": obj.get("keyword_data.keyword"),
            "keyword_data.keyword_info.last_updated_time": obj.get("keyword_data.keyword_info.last_updated_time"),
            "keyword_data.keyword_info.competition": obj.get("keyword_data.keyword_info.competition"),
            "keyword_data.keyword_info.cpc": obj.get("keyword_data.keyword_info.cpc"),
            "keyword_data.keyword_info.search_volume": obj.get("keyword_data.keyword_info.search_volume"),
            "keyword_data.keyword_properties.core_keyword": obj.get("keyword_data.keyword_properties.core_keyword"),
            "keyword_data.keyword_properties.synonym_clustering_algorithm": obj.get("keyword_data.keyword_properties.synonym_clustering_algorithm"),
            "keyword_data.keyword_properties.keyword_difficulty": obj.get("keyword_data.keyword_properties.keyword_difficulty"),
            "keyword_data.keyword_properties.detected_language": obj.get("keyword_data.keyword_properties.detected_language"),
            "keyword_data.keyword_properties.is_another_language": obj.get("keyword_data.keyword_properties.is_another_language"),
            "keyword_data.serp_info.check_url": obj.get("keyword_data.serp_info.check_url"),
            "keyword_data.serp_info.se_results_count": obj.get("keyword_data.serp_info.se_results_count"),
            "keyword_data.serp_info.last_updated_time": obj.get("keyword_data.serp_info.last_updated_time"),
            "keyword_data.serp_info.previous_updated_time": obj.get("keyword_data.serp_info.previous_updated_time"),
            "keyword_data.serp_info.serp_item_types": obj.get("keyword_data.serp_info.serp_item_types")
        })
        return _obj


