# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dataforseo_client.models.ranked_keywords_bing_dataforseo_labs_available_filters_bing_info import RankedKeywordsBingDataforseoLabsAvailableFiltersBingInfo
from dataforseo_client.models.ranked_keywords_google_dataforseo_labs_available_filters_google_info import RankedKeywordsGoogleDataforseoLabsAvailableFiltersGoogleInfo
from typing import Optional, Set
from typing_extensions import Self

class RankedKeywordsInfo(BaseModel):
    """
    RankedKeywordsInfo
    """ # noqa: E501
    google: Optional[RankedKeywordsGoogleDataforseoLabsAvailableFiltersGoogleInfo] = None
    bing: Optional[RankedKeywordsBingDataforseoLabsAvailableFiltersBingInfo] = None
    amazon: Optional[Dict[str, Optional[StrictStr]]] = None
    __properties: ClassVar[List[str]] = ["google", "bing", "amazon"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RankedKeywordsInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of google
        if self.google:
            _dict['google'] = self.google.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bing
        if self.bing:
            _dict['bing'] = self.bing.to_dict()
        # set to None if amazon (nullable) is None
        # and model_fields_set contains the field
        if self.amazon is None and "amazon" in self.model_fields_set:
            _dict['amazon'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RankedKeywordsInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "google": RankedKeywordsGoogleDataforseoLabsAvailableFiltersGoogleInfo.from_dict(obj["google"]) if obj.get("google") is not None else None,
            "bing": RankedKeywordsBingDataforseoLabsAvailableFiltersBingInfo.from_dict(obj["bing"]) if obj.get("bing") is not None else None,
            "amazon": obj.get("amazon")
        })
        return _obj


